﻿/***************************************************
 * ntko office文档控件c#示例代码
 * 本示例演示了ntko office文档控件的常用功能。所有文档控件相关方法的详细详细说明，请查看：
 * 《ntko office 文档控件开发接口参考》。
 * 下载地址:http://www.ntko.com/admin/homepagenew.nsf/download/OfficeControl.rar/$File/OfficeControl.rar
 *                              www.ntko.com
 *                                 2010.6.16
 *                 copy right by ntko.naruto
 **************************************************/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace NtkoOCWinFromCSharpDemo
{
    public partial class Form1 : Form
    {
        private bool IsDocOpended = false;
        private string AppLocation = Application.StartupPath;
        private void ResizeControl()
        {
            tabControl1.Height = this.ClientSize.Height;
            tabControl1.Width  = 110;
            tabControl1.Top = 0;
            tabControl1.Left = this.ClientSize.Width - tabControl1.Width;
            axOfficeControl1.Width = this.ClientSize.Width - tabControl1.Width;
            axOfficeControl1.Height = this.ClientSize.Height;
            axOfficeControl1.Top  = 0;
            axOfficeControl1.Left = 0;
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ResizeControl();
            if (!IsDocOpended)
            {
                axOfficeControl1.CreateNew("word.document");
            }
        }

        private void Form1_SizeChanged(object sender, EventArgs e)
        {
            ResizeControl();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            try
            {
                axOfficeControl1.ShowDialog(OfficeControlLIB.ntkoShowDialogType.ntkoDialogPageSetup);
            }
            catch(Exception err)
            { }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            object path = @"c:\ntko office文档控件中的文档.doc";
            object isoverwrite = true;
            MessageBox.Show(@"文件将保存到:" + path + ",并覆盖原文件!");
            axOfficeControl1.SaveToLocal(path, isoverwrite);
        }

        private void axOfficeControl1_OnDocumentOpened(object sender, AxOfficeControlLIB.IDOfficeCtlEvents_OnDocumentOpenedEvent e)
        {
            IsDocOpended = true;
        }

        

        private void axOfficeControl1_OnDocumentClosed(object sender, EventArgs e)
        {
            IsDocOpended = false;
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            object signKey = "sign key";
            object top = 0, left = 0, relative = 1, scale = 100;
            axOfficeControl1.DoHandSign2("userName", signKey, left, top, relative, scale);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            axOfficeControl1.DoHandDraw2();

        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            object signKey = "sign key";
            object top = 0, left = 0, relative = 1, scale = 100;
            axOfficeControl1.FullScreenMode = true;
            axOfficeControl1.DoHandSign2("userName", signKey, left, top, relative, scale);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            axOfficeControl1.FullScreenMode = true;
            axOfficeControl1.DoHandDraw2();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            object top = 0, left = 0, relative = 1, scale = 100, zorder = 0;
            object isPromptSelect = true;
            object signKey = "sign key";
            object passWord = "";
            axOfficeControl1.AddSignFromLocal("ntko", "", 
                        isPromptSelect, 
                        left, top, signKey, relative, 
                        scale, zorder, passWord);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            object isSilent = false, signKey = "sign key";
            axOfficeControl1.DoCheckSign(isSilent, signKey);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            axOfficeControl1.PrintPreview();
        }

        private void button9_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            axOfficeControl1.PrintOut();
        }

        private void button11_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            object path = @"c:\ntko office文档控件中的文档.doc";
            object isoverwrite = true;
            MessageBox.Show(@"文件将保存到:" + path + ",并覆盖原文件!");
            axOfficeControl1.SaveToLocal(path, isoverwrite);
            MessageBox.Show(@"文件已经保存,窗口即将关闭!");
            Close();
        }

        private void button17_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            axOfficeControl1.Close();
        }

        private void button16_Click(object sender, EventArgs e)
        {
            axOfficeControl1.Visible = !axOfficeControl1.Visible;
        }

        private void button12_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            axOfficeControl1.ShowDialog(OfficeControlLIB.ntkoShowDialogType.ntkoDialogSave);
        }

        private void button13_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            if (axOfficeControl1.DocType != 1)//word文档类型
            {
                MessageBox.Show("不能在非word文档类型中调用模版套红!");
                return;
            }
            object isPromptSelect = true, isCfConversinon = true;
            axOfficeControl1.AddTemplateFromLocal(AppLocation +@"\ntko_TemplatedWordfile.doc", isPromptSelect, isCfConversinon);
        }

        private void button14_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            MessageBox.Show("将插入图片文件:" + AppLocation + "ntko_Picture.bmp,到文档中!");
            axOfficeControl1.AddPicFromLocal(AppLocation + @"\ntko_Picture.bmp");
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            Microsoft.Office.Interop.Word.Document doc =
                (Microsoft.Office.Interop.Word.Document)axOfficeControl1.ActiveDocument;
            if (checkBox1.Checked == true)
            {
                doc.TrackRevisions = true;
                doc.ShowRevisions = true;
            }
            else
            {
                doc.TrackRevisions = false;
                doc.ShowRevisions = false;
            }
        }

        private void button18_Click(object sender, EventArgs e)
        {
            axOfficeControl1.CreateNew("word.document");
        }

        private void button19_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            if (axOfficeControl1.IsNTKOSecSignInstalled())
            {
                object isPromptSelect = true;
                object top = 0, left = 0, relative = 1, scale = 100, zorder = 0;
                object printmode = 2,
                       isusecertificate = false,
                       islocked = false,
                       ischeckdocchange = true,
                       isshowui = true, 
                       signpass = "password",
                       isaddcomment = true,
                       isbelowtext = true;
                try
                {
                    axOfficeControl1.AddSecSignFromLocal("ntko", this.AppLocation + @"\ntko_secsign.esp",
                        isPromptSelect, left, top, relative, printmode,
                        isusecertificate, islocked, ischeckdocchange,
                        isshowui, signpass, isaddcomment, isbelowtext);
                }
                catch(Exception err)
                {
                    MessageBox.Show("调用ntko 安全印章系统功能出错,请尝试重新安装ntko 安全签名印章系统.\n" +
                        "ntko安全印章系统下载地址:http://www.ntko.com");
                }
                //axOfficeControl1.AddSecSignFromLocal("ntko", this.AppLocation + @"\ntko_secsign.esp");

            }
            else
            {
                MessageBox.Show("尚未安装ntko office安全签名印章系统,不能调用此功能.\n" +
                        "请到www.ntko.com下载安装");
            }
        }

        private void button20_Click(object sender, EventArgs e)
        {
            if (!IsDocOpended)
                return;
            if (axOfficeControl1.IsNTKOSecSignInstalled())
            {
                try
                {
                    axOfficeControl1.AddSecHandSign("ntko");
                }
                catch (Exception err)
                {
                    MessageBox.Show("调用ntko 安全印章系统功能出错,请尝试重新安装ntko 安全签名印章系统.\n" +
                        "ntko安全印章系统下载地址:http://www.ntko.com");
                }
            }
            else
            {
                MessageBox.Show("尚未安装ntko office安全签名印章系统,不能调用此功能.\n" +
                        "请到www.ntko.com下载安装");
            }
        }

    }
}
